Index: guix/.guix-packages/python.scm
===================================================================
--- guix/.guix-packages/python.scm	(revision 7bfb563bd9fae2bbcfdcd8c4df8db1ad44ef8ca7)
+++ guix/.guix-packages/python.scm	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
@@ -1,336 +1,1 @@
-(define-module (python)
-  #:use-module ((guix licenses) #:prefix license:)
-  #:use-module (gnu packages)
-  #:use-module (gnu packages base)
-  #:use-module (gnu packages bash)
-  #:use-module (gnu packages certs)
-  #:use-module (gnu packages check)
-  #:use-module (gnu packages compression)
-  #:use-module (gnu packages dbm)
-  #:use-module (gnu packages time)
-  #:use-module (gnu packages databases)
-  #:use-module (gnu packages hurd)
-  #:use-module (gnu packages libffi)
-  #:use-module (gnu packages ncurses)
-  #:use-module (gnu packages pkg-config)
-  #:use-module (gnu packages python-xyz)
-  #:use-module (gnu packages python-web)
-  #:use-module (gnu packages readline)
-  #:use-module (gnu packages shells)
-  #:use-module (gnu packages sqlite)
-  #:use-module (gnu packages tcl)
-  #:use-module (gnu packages tls)
-  #:use-module (gnu packages xml)
-  #:use-module (guix gexp)
-  #:use-module (guix packages)
-  #:use-module (guix download)
-  #:use-module (guix utils)
-  #:use-module (guix build-system gnu)
-  #:use-module (guix build-system python)
-  #:use-module (guix build-system trivial)
-  #:use-module (srfi srfi-1)
-  #:use-module (srfi srfi-26)
-
-  #:export (customize-site
-            guix-pythonpath-search-path))
-
-(define-public python-types-urllib3
-  (package
-    (name "python-types-urllib3")
-    (version "1.26.11")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-urllib3" version))
-        (sha256
-          (base32 "0nri65gfihl4wcbi33wwcksmh5g3ibhjs0hxbyq1x1b82524xmi4"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for urllib3")
-    (description "Typing stubs for urllib3")
-    (license #f)))
-
-(define-public python-types-requests
-  (package
-    (name "python-types-requests")
-    (version "2.27.16")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-requests" version))
-        (sha256
-          (base32 "16zypz2csgw0c86ffmyn7mljbg1h4phxnlhl1fvfz9win8c0q0f8"))))
-    (build-system python-build-system)
-    (propagated-inputs (list python-types-urllib3))
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for requests")
-    (description "Typing stubs for requests")
-    (license #f)))
-
-(define-public python-types-pyyaml
-  (package
-    (name "python-types-pyyaml")
-    (version "6.0.5")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-PyYAML" version))
-        (sha256
-          (base32 "0blavmg6f0xapjba1sh2rnvrdjx5dps1r3h3ihxdilgk2h4hakj6"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for PyYAML")
-    (description "Typing stubs for PyYAML")
-    (license #f)))
-
-(define-public python-types-pytz
-  (package
-    (name "python-types-pytz")
-    (version "2021.3.6")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-pytz" version))
-        (sha256
-          (base32 "14yr5hg2ww8s4a0mz2bkd549fv8qgm538fnzxvqv92ld1pcpym3l"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for pytz")
-    (description "Typing stubs for pytz")
-    (license #f)))
-
-(define-public python-types-psycopg2
-  (package
-    (name "python-types-psycopg2")
-    (version "2.9.9")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-psycopg2" version))
-        (sha256
-          (base32 "0bhaybs5rl864yw2w1qapbpihp4a798z3m2yzl0dqhxkxr94v7ag"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for psycopg2")
-    (description "Typing stubs for psycopg2")
-    (license #f)))
-
-(define-public python-types-werkzeug
-  (package
-    (name "python-types-werkzeug")
-    (version "1.0.9")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-Werkzeug" version))
-        (sha256
-          (base32 "132im9g3m7hv57g3zq30qj7qfpv5jxiyw354aba360a09ih6khjw"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for Werkzeug")
-    (description "Typing stubs for Werkzeug")
-    (license #f)))
-
-(define-public python-types-markupsafe
-  (package
-    (name "python-types-markupsafe")
-    (version "1.1.10")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-MarkupSafe" version))
-        (sha256
-          (base32 "1c8iczhgiyw7f92mhbq3j9038g0rj3sqwamclnisw0ixd1raicw5"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for MarkupSafe")
-    (description "Typing stubs for MarkupSafe")
-    (license #f)))
-
-(define-public python-types-jinja2
-  (package
-    (name "python-types-jinja2")
-    (version "2.11.9")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-Jinja2" version))
-        (sha256
-          (base32 "10cc9d6hikrv28sqn84lhi8qchpyy3l8jkby1d9fsyms1aj79p6v"))))
-    (build-system python-build-system)
-    (propagated-inputs (list python-types-markupsafe))
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for Jinja2")
-    (description "Typing stubs for Jinja2")
-    (license #f)))
-
-(define-public python-types-flask
-  (package
-    (name "python-types-flask")
-    (version "1.1.6")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-Flask" version))
-        (sha256
-          (base32 "1kz9cdbirfxa79vvy777bdpfl8ygf60x1xh1ddp47ygzmfrpgixa"))))
-    (build-system python-build-system)
-    (propagated-inputs
-      (list python-types-click python-types-jinja2 python-types-werkzeug))
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for Flask")
-    (description "Typing stubs for Flask")
-    (license #f)))
-
-(define-public python-types-click
-  (package
-    (name "python-types-click")
-    (version "7.1.8")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "types-click" version))
-        (sha256
-          (base32 "14p0yjzxpw0jfkyhx16bl2kvla0ai9q51jhicd8xq0b4prl4jq5n"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/python/typeshed")
-    (synopsis "Typing stubs for click")
-    (description "Typing stubs for click")
-    (license #f)))
-
-(define-public python-systemd-python
-  (package
-    (name "python-systemd-python")
-    (version "234")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "systemd-python" version))
-        (sha256
-          (base32 "1rw3vfakils7h0i93cyi5hvvdc5mgq5cp4n2mmdf9npaf2zl83px"))))
-    (build-system python-build-system)
-    (home-page "https://github.com/systemd/python-systemd")
-    (synopsis "Python interface for libsystemd")
-    (description "Python interface for libsystemd")
-    (license #f)))
-
-(define-public python-gunicorn
-  (package
-    (name "python-gunicorn")
-    (version "20.1.0")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "gunicorn" version))
-        (sha256
-          (base32 "1s7670qw36x90bgmazmgib170i5gnpyb2ypxzlla7y0mpasniag0"))))
-    (build-system python-build-system)
-    (arguments
-     `(#:tests? #f))
-    (propagated-inputs (list python-setuptools))
-    (home-page "https://gunicorn.org")
-    (synopsis "WSGI HTTP Server for UNIX")
-    (description "WSGI HTTP Server for UNIX")
-    (license license:expat)))
-
-(define-public python-aiohttp-utils
-  (package
-    (name "python-aiohttp-utils")
-    (version "3.1.1")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "aiohttp_utils" version))
-        (sha256
-          (base32 "056w0aw3nnnhwzrn8rrsn7hbmxb5yd7iz8h4m4x1kzd32pfc9wh8"))))
-    (build-system python-build-system)
-    (arguments
-     `(#:tests? #f))
-    (propagated-inputs (list python-aiohttp python-gunicorn python-mimeparse))
-    (home-page "https://github.com/sloria/aiohttp_utils")
-    (synopsis "Handy utilities for aiohttp.web applications.")
-    (description "Handy utilities for aiohttp.web applications.")
-    (license license:expat)))
-
-(define-public python-mirakuru
-  (package
-    (name "python-mirakuru")
-    (version "2.4.2")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "mirakuru" version))
-        (sha256
-          (base32 "09l2a2c2mh422j43q8n1l0vg14la34ynp32r1v5rdjjb3gcd917c"))))
-    (build-system python-build-system)
-    (propagated-inputs (list python-psutil))
-    (native-inputs (list python-daemon python-pytest python-pytest-cov))
-    (home-page "https://github.com/ClearcodeHQ/mirakuru")
-    (synopsis "Process executor (not only) for tests.")
-    (description "Process executor (not only) for tests.")
-    (license #f)))
-
-(define-public python-pytest-postgresql
-  (package
-    (name "python-pytest-postgresql")
-    (version "4.1.1")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "pytest-postgresql" version))
-        (sha256
-          (base32 "0p99j6wm36s0xz3zxi8qyir0ajnxpzcjb00f3z5xwh8603s6lk8l"))))
-    (build-system python-build-system)
-    (propagated-inputs
-      (list python-mirakuru python-port-for python-pytest python-setuptools))
-    (native-inputs (list python-pytest-cov python-pytest-xdist))
-    (home-page "https://github.com/ClearcodeHQ/pytest-postgresql")
-    (synopsis "Postgresql fixtures and fixture factories for Pytest.")
-    (description "Postgresql fixtures and fixture factories for Pytest.")
-    (license #f)))
-
-(define-public python-swh.core
-  (package
-    (name "python-swh.core")
-    (version "2.4.0")
-    (source
-      (origin
-        (method url-fetch)
-        (uri (pypi-uri "swh.core" version))
-        (sha256
-          (base32 "17dyqq1z774xnbjak4ncdrbp6acnbrmks0636fw1rmqq728rzz68"))))
-    (build-system python-build-system)
-    (propagated-inputs
-      (list python-click
-            python-deprecated
-            python-magic
-            python-pyyaml
-            python-sentry-sdk))
-    (native-inputs
-      (list python-aiohttp
-            python-aiohttp-utils
-            python-blinker
-            python-flask
-            python-hypothesis
-            python-iso8601
-            python-msgpack
-            python-psycopg2
-            python-pytest
-            python-pytest-mock
-            python-pytest-postgresql
-            python-pytz
-            python-requests
-            python-requests-mock
-            ;;python-systemd-python
-            python-types-click
-            python-types-flask
-            python-types-psycopg2
-            python-types-pytz
-            python-types-pyyaml
-            python-types-requests
-            python-typing-extensions))
-    (home-page "https://forge.softwareheritage.org/diffusion/DCORE/")
-    (synopsis "Software Heritage core utilities")
-    (description "Software Heritage core utilities")
-    (license #f)))
-
+/gnu/store/jafbqipm2a88dppzq6y9r2fhmpznb293-home-dotfiles--guix-packages-python-scm
Index: guix/config-desktop.scm
===================================================================
--- guix/config-desktop.scm	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
+++ guix/config-desktop.scm	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
@@ -0,0 +1,154 @@
+(use-modules (gnu)
+	     (guix transformations)
+	     (gnu home)
+             (guix gexp)
+ 	     (nongnu packages linux)
+	     (nongnu system linux-initrd)
+             (gnu home services shells))
+
+(use-service-modules guix cups desktop networking ssh xorg docker nix admin vnc lightdm syncthing virtualization databases)
+(use-package-modules gnome xdisorg vnc databases)
+
+(load "/home/w96k/projects/dotfiles/guix/.dotfiles/home-configuration.scm")
+
+(define wkz-transform
+  ;; The package transformation procedure.
+  (options->transformation
+   '((tune . "skylake"))))
+
+(operating-system
+ (locale "en_US.utf8")
+ (timezone "Asia/Tbilisi")
+ (kernel linux)
+ (initrd microcode-initrd)
+ (firmware (list linux-firmware))
+ (keyboard-layout (keyboard-layout "us,ru"
+                                   #:options '("grp:shifts_toggle" "ctrl:nocaps")))
+ (host-name "wkz-guix")
+
+ ;; The list of user accounts ('root' is implicit).
+ (users (cons* (user-account
+                (name "w96k")
+                (comment "W96K")
+                (group "users")
+                (home-directory "/home/w96k")
+                (supplementary-groups '("wheel" "netdev" "audio" "video" "docker")))
+	       (user-account
+                (name "wkz")
+                (comment "wkz")
+                (group "users")
+                (home-directory "/home/wkz")
+                (supplementary-groups '("wheel" "netdev" "audio" "video" "docker")))
+               %base-user-accounts))
+
+ ;; (packages %base-packages)
+ (packages
+  (append
+   (map
+    specification->package
+    '(
+      "ratpoison"
+      "xterm"
+      ))
+   %base-packages))
+
+ ;; Below is the list of system services.  To search for available
+ ;; services, run 'guix system search KEYWORD' in a terminal.
+ (services
+  (append (list
+	   (service guix-home-service-type `(("w96k" ,wkz-home) ("wkz" ,wkz-home)))
+	   (service block-facebook-hosts-service-type)
+
+	   (service tor-service-type)
+	   (service openssh-service-type)
+	   (service containerd-service-type)
+	   (service docker-service-type)
+	   ;; (service hurd-vm-service-type
+           ;;   (hurd-vm-configuration
+           ;;    (disk-size (* 5000 (expt 2 20))) ;5G
+           ;;    (memory-size 1024)))
+	   
+	   (service nix-service-type (nix-configuration
+				      (extra-options '("--extra-experimental-features nix-command"))))
+
+	   (service xvnc-service-type (xvnc-configuration
+                                       (display-number 10)
+                                       (localhost? #f)
+                                       (geometry "1280x800")))
+
+	   (service syncthing-service-type
+		    (syncthing-configuration
+		     (user "w96k")))
+
+	   (service postgresql-service-type
+		    (postgresql-configuration
+		     (postgresql postgresql-15)))
+
+	   (service connman-service-type)
+
+	   ;; (service screen-locker-service-type
+           ;;  (screen-locker-configuration
+           ;;   (name "xlock")
+           ;;   (program (file-append xlockmore "/bin/xlock"))))
+
+	   ;; (service slim-service-type
+	   ;;    (slim-configuration
+	   ;;     (default-user "w96k")
+	   ;;    (xorg-configuration
+	   ;;      (xorg-configuration	   
+	   ;;       (keyboard-layout keyboard-layout)))))
+	   )
+
+	  (modify-services %desktop-services
+			   (delete screen-locker-service-type)
+			   (delete modem-manager-service-type)
+			   (delete udisks-service-type)
+			   (delete upower-service-type)
+			   (delete network-manager-service-type)
+			   (delete usb-modeswitch-service-type)
+			   (delete geoclue-service-type)
+			   
+			   
+			   (guix-service-type config => (guix-configuration
+							 (inherit config)
+							 (extra-options '("--max-jobs=10"))
+							 (substitute-urls
+							  (append (list "https://substitutes.nonguix.org")
+								  %default-substitute-urls))
+							 (authorized-keys
+							  (append (list (plain-file "non-guix.pub"
+										    "
+(public-key 
+ (ecc 
+  (curve Ed25519)
+  (q #C1FD53E5D4CE971933EC50C9F307AE2171A2D3B52C804642A7A35F84F3A4EA98#)
+  )
+ )
+"))
+								  %default-authorized-guix-keys))))
+			   
+			   (delete gdm-service-type))))
+
+ (bootloader (bootloader-configuration
+              (bootloader grub-efi-bootloader)
+              (targets (list "/boot/efi"))
+              (keyboard-layout keyboard-layout)))
+ (mapped-devices (list (mapped-device
+                        (source (uuid
+                                 "6cfe9eed-8cdd-43da-9b9f-cec6f8ec538b"))
+                        (target "cryptroot")
+                        (type luks-device-mapping))))
+
+ (file-systems (cons* (file-system
+                       (mount-point "/boot/efi")
+                       (device (uuid "17C5-3E35"
+                                     'fat32))
+                       (type "vfat"))
+                      (file-system
+                       (mount-point "/")
+                       (device "/dev/mapper/cryptroot")
+                       (type "ext4")
+		       (options "discard")
+		       (skip-check-if-clean? #f)
+		       (repair #t)
+                       (dependencies mapped-devices)) %base-file-systems)))
Index: guix/config-desktop.scm~
===================================================================
--- guix/config-desktop.scm~	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
+++ guix/config-desktop.scm~	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
@@ -0,0 +1,154 @@
+(use-modules (gnu)
+	     (guix transformations)
+	     (gnu home)
+             (guix gexp)
+ 	     (nongnu packages linux)
+	     (nongnu system linux-initrd)
+             (gnu home services shells))
+
+(use-service-modules guix cups desktop networking ssh xorg docker nix admin vnc lightdm syncthing virtualization databases)
+(use-package-modules gnome xdisorg vnc databases)
+
+(load "/home/w96k/projects/dotfiles/guix/home/home-configuration.scm")
+
+(define wkz-transform
+  ;; The package transformation procedure.
+  (options->transformation
+   '((tune . "skylake"))))
+
+(operating-system
+ (locale "en_US.utf8")
+ (timezone "Asia/Tbilisi")
+ (kernel linux)
+ (initrd microcode-initrd)
+ (firmware (list linux-firmware))
+ (keyboard-layout (keyboard-layout "us,ru"
+                                   #:options '("grp:shifts_toggle" "ctrl:nocaps")))
+ (host-name "wkz-guix")
+
+ ;; The list of user accounts ('root' is implicit).
+ (users (cons* (user-account
+                (name "w96k")
+                (comment "W96K")
+                (group "users")
+                (home-directory "/home/w96k")
+                (supplementary-groups '("wheel" "netdev" "audio" "video" "docker")))
+	       (user-account
+                (name "wkz")
+                (comment "wkz")
+                (group "users")
+                (home-directory "/home/wkz")
+                (supplementary-groups '("wheel" "netdev" "audio" "video" "docker")))
+               %base-user-accounts))
+
+ ;; (packages %base-packages)
+ (packages
+  (append
+   (map
+    specification->package
+    '(
+      "ratpoison"
+      "xterm"
+      ))
+   %base-packages))
+
+ ;; Below is the list of system services.  To search for available
+ ;; services, run 'guix system search KEYWORD' in a terminal.
+ (services
+  (append (list
+	   (service guix-home-service-type `(("w96k" ,wkz-home) ("wkz" ,wkz-home)))
+	   (service block-facebook-hosts-service-type)
+
+	   (service tor-service-type)
+	   (service openssh-service-type)
+	   (service containerd-service-type)
+	   (service docker-service-type)
+	   ;; (service hurd-vm-service-type
+           ;;   (hurd-vm-configuration
+           ;;    (disk-size (* 5000 (expt 2 20))) ;5G
+           ;;    (memory-size 1024)))
+	   
+	   (service nix-service-type (nix-configuration
+				      (extra-options '("--extra-experimental-features nix-command"))))
+
+	   (service xvnc-service-type (xvnc-configuration
+                                       (display-number 10)
+                                       (localhost? #f)
+                                       (geometry "1280x800")))
+
+	   (service syncthing-service-type
+		    (syncthing-configuration
+		     (user "w96k")))
+
+	   (service postgresql-service-type
+		    (postgresql-configuration
+		     (postgresql postgresql-15)))
+
+	   (service connman-service-type)
+
+	   ;; (service screen-locker-service-type
+           ;;  (screen-locker-configuration
+           ;;   (name "xlock")
+           ;;   (program (file-append xlockmore "/bin/xlock"))))
+
+	   ;; (service slim-service-type
+	   ;;    (slim-configuration
+	   ;;     (default-user "w96k")
+	   ;;    (xorg-configuration
+	   ;;      (xorg-configuration	   
+	   ;;       (keyboard-layout keyboard-layout)))))
+	   )
+
+	  (modify-services %desktop-services
+			   (delete screen-locker-service-type)
+			   (delete modem-manager-service-type)
+			   (delete udisks-service-type)
+			   (delete upower-service-type)
+			   (delete network-manager-service-type)
+			   (delete usb-modeswitch-service-type)
+			   (delete geoclue-service-type)
+			   
+			   
+			   (guix-service-type config => (guix-configuration
+							 (inherit config)
+							 (extra-options '("--max-jobs=10"))
+							 (substitute-urls
+							  (append (list "https://substitutes.nonguix.org")
+								  %default-substitute-urls))
+							 (authorized-keys
+							  (append (list (plain-file "non-guix.pub"
+										    "
+(public-key 
+ (ecc 
+  (curve Ed25519)
+  (q #C1FD53E5D4CE971933EC50C9F307AE2171A2D3B52C804642A7A35F84F3A4EA98#)
+  )
+ )
+"))
+								  %default-authorized-guix-keys))))
+			   
+			   (delete gdm-service-type))))
+
+ (bootloader (bootloader-configuration
+              (bootloader grub-efi-bootloader)
+              (targets (list "/boot/efi"))
+              (keyboard-layout keyboard-layout)))
+ (mapped-devices (list (mapped-device
+                        (source (uuid
+                                 "6cfe9eed-8cdd-43da-9b9f-cec6f8ec538b"))
+                        (target "cryptroot")
+                        (type luks-device-mapping))))
+
+ (file-systems (cons* (file-system
+                       (mount-point "/boot/efi")
+                       (device (uuid "17C5-3E35"
+                                     'fat32))
+                       (type "vfat"))
+                      (file-system
+                       (mount-point "/")
+                       (device "/dev/mapper/cryptroot")
+                       (type "ext4")
+		       (options "discard")
+		       (skip-check-if-clean? #f)
+		       (repair #t)
+                       (dependencies mapped-devices)) %base-file-systems)))
Index: guix/config-thinkpad.scm
===================================================================
--- guix/config-thinkpad.scm	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
+++ guix/config-thinkpad.scm	(revision 254aa1d44b1575434f9f92ace2e1ea12280d028c)
@@ -0,0 +1,336 @@
+;; -*- geiser-scheme-implementation: guile -*-
+
+(use-modules (gnu)
+	     (gnu packages)
+	     (srfi srfi-1))
+
+(use-service-modules
+ desktop
+ databases
+ networking
+ ssh
+ xorg
+ docker
+ virtualization
+ dbus
+ linux
+ pm
+ vpn
+ nix)
+
+(use-package-modules
+ wm
+ lisp
+ bash
+ linux
+ python
+ gnome
+ gawk
+ xorg
+ xdisorg)
+
+;; (define-public linux-libre-custom
+;;   (package
+;;     (inherit linux-libre)
+;;     (native-inputs
+;;      `(("kconfig" ,(local-file "fb.config"))
+;;       ,@(alist-delete "kconfig"
+;;                       (package-native-inputs linux-libre))))))
+
+(define %cpupower-service
+  (simple-service
+   'cpupower activation-service-type
+   #~(zero? (system* #$(file-append cpupower "/bin/cpupower")
+		     "frequency-set" "--governor" "schedutil"))))
+
+(define %x86-energy-perf-policy-service
+  (simple-service
+   'x86-energy-perf-policy-service activation-service-type
+   #~(zero? (system* #$(file-append x86-energy-perf-policy "/bin/x86_energy_perf_policy")
+		     "--turbo-enable" "0"
+		     "--hwp-desired" "16"))))
+
+(define %thinkfan-service
+  (simple-service
+   'thinkfan activation-service-type
+   #~(zero? (system* #$(file-append thinkfan "/sbin/thinkfan")))))
+
+
+(define i915-config
+  (plain-file "i915.conf"
+              "options i915 enable_fbc=1 enable_dc=0 modeset=1 enable_psr=0"))
+
+(define drm-kms-config
+  (plain-file "drm_kms.conf"
+              "options drm_kms_helper poll=N"))
+
+(define thinkpad-acpi-config
+  (plain-file "thinkpad_acpi.conf"
+              "options thinkpad_acpi fan_control=1"))
+
+;; tp_thermal /proc/acpi/ibm/thermal
+
+(define thinkfan-config
+  (plain-file "thinkfan.conf"
+   "\
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp3_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp5_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp1_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp4_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp6_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp7_input
+hwmon /sys/devices/platform/thinkpad_hwmon/hwmon/hwmon4/temp8_input
+hwmon /sys/devices/pci0000:00/0000:00:1f.2/ata1/host0/target0:0:0/0:0:0:0/hwmon/hwmon1/temp1_input
+hwmon /sys/devices/pci0000:00/0000:00:1f.2/ata2/host1/target1:0:0/1:0:0:0/hwmon/hwmon2/temp1_input
+# hwmon /sys/devices/platform/coretemp.0/hwmon/hwmon6/temp3_input
+# hwmon /sys/devices/platform/coretemp.0/hwmon/hwmon6/temp2_input
+hwmon /sys/devices/virtual/thermal/thermal_zone0/hwmon0/temp1_input
+hwmon /sys/devices/virtual/thermal/thermal_zone0/hwmon0/temp2_input
+tp_fan /proc/acpi/ibm/fan
+
+(0, 0, 35)
+(1, 30, 40)
+(2, 35, 50)
+(3, 45, 60)
+(4, 55, 65)
+(5, 60, 70)
+(6, 65, 75)
+(7, 70, 85)
+(\"level full-speed\", 78, 120)"))
+
+(define fancontrol-config
+  (plain-file "fancontrol"
+	      "
+INTERVAL=10
+DEVPATH=hwmon0=devices/virtual/thermal/thermal_zone0 hwmon1=devices/platform/thinkpad_hwmon
+DEVNAME=hwmon0=acpitz hwmon5=thinkpad
+FCTEMPS=hwmon1/pwm1=hwmon0/temp1_input
+FCFANS= hwmon1/pwm1=hwmon5/fan1_input
+MINTEMP=hwmon1/pwm1=20
+MAXTEMP=hwmon1/pwm1=50
+MINSTART=hwmon1/pwm1=150
+MINSTOP=hwmon1/pwm1=50
+MINPWM=hwmon1/pwm1=10"))
+
+(operating-system
+ (locale "ru_RU.utf8")
+ (timezone "Europe/Tbilisi")
+ (keyboard-layout
+  (keyboard-layout
+   "us,ru"
+   #:options
+   '("grp:shifts_toggle"
+     "caps:ctrl_modifier")))
+ ;; (kernel linux-libre-5.19)
+ ;; (kernel-loadable-modules '(acpi-call-linux-module))
+ (kernel-arguments
+   '("consoleblank=0"
+     ;; "processor.max_cstate=3"  ; Disable power savings
+     ;; "intel_idle.max_cstate=0" ; (cstate 3-4 provides
+     ;; 		     			; high freq cpu noice)
+     "vblank_mode=0"
+     ;;"vm.swappiness=5"
+     "thinkpad_acpi.fan_control=1"
+     "acpi_sleep=s3_bios"
+     "acpi_osi=Linux"
+     "i915.modeset=1"
+     ;; "i915.enable_dc=0"
+     ;; "i915.enable_psr=0"
+     "rootfstype=ext4"
+     "KVM"
+     "loglevel=7"
+     ;;"logo"
+     "ahci.mobile_lpm_policy=1"
+     "intremap=off"     ; Fix for failed to map dmar2
+     "modprobe.blacklist=pcspkr,usbmouse,usbkbd,glx"))
+ (host-name "w96k-x200t")
+ (users
+  (cons*
+   (user-account
+    (name "w96k")
+    (comment "Mikhail Kirillov")
+    (group "users")
+    (home-directory "/home/w96k")
+    (supplementary-groups
+     '("wheel" "netdev" "audio" "video" "kvm" "docker")))
+   %base-user-accounts))
+ (packages
+  (append
+   (map
+    specification->package
+    '("xterm"
+      "xinit"
+      "xorg-server"
+      "font-gnu-unifont"
+      "font-gnu-freefont"
+      "mesa"
+      "mesa-utils"
+      "ratpoison"
+      "wmname"
+      "windowmaker" 
+      "nss-certs"
+      "docker-compose"
+      "thinkfan"
+      "cpupower"
+      "lm-sensors"
+      "x86-energy-perf-policy"
+      "git"
+      "stow"
+      "lm-sensors"
+      "xset"
+      "cpuid"
+      ;; Video Codecs stuff
+      "gstreamer"
+      "gst-plugins-base"
+      "gst-plugins-good"
+      "gst-plugins-bad"
+      "gst-plugins-ugly"
+      "gst-libav"
+      ;; "intel-vaapi-driver-g45-h264"
+      "libva-utils"
+      "igt-gpu-tools"
+      ;; Xorg      
+      "xev"
+      "xset"
+      "xrdb"
+      "xhost"
+      "xmodmap"
+      "setxkbmap"
+      "xrandr"
+      "arandr"
+      "xss-lock"
+      "libinput"
+      "xinput"
+      "xf86-input-libinput"
+      ;; "xf86-video-fbdev"
+      "xf86-video-intel"
+      "qemu"))
+   %base-packages))
+ 
+ (services
+  (cons*
+   (service docker-service-type)
+   (service thermald-service-type)
+   (service virtlog-service-type)
+   (service libvirt-service-type
+            (libvirt-configuration (unix-sock-group "libvirt")))
+   (service openssh-service-type)
+   (service tor-service-type)
+
+   ;;Wacom tablet support
+   (service inputattach-service-type
+	    (inputattach-configuration
+	     (device "/dev/ttyS4")
+	     (device-type "wacom")))
+
+   (service kernel-module-loader-service-type
+            '("thinkpad_acpi"
+	      "msr"
+	      "coretemp"
+	      "acpi_cpufreq"
+	      "overlay"))
+
+   (simple-service 'thinkpad-acpi-config etc-service-type
+		   (list `("modprobe.d/thinkpad_acpi.conf"
+			   ,thinkpad-acpi-config)))
+
+   ;; (simple-service 'fancontrol-config etc-service-type
+   ;; 		   (list `("fancontrol"
+   ;; 			   ,fancontrol-config)))
+
+   ;; (simple-service 'thinkfan-config etc-service-type
+   ;; 		   (list `("thinkfan.conf"
+   ;; 			   ,thinkfan-config)))
+
+   (simple-service 'i915-config etc-service-type
+		   (list `("modprobe.d/i915.conf"
+			   ,i915-config)))
+
+   (simple-service 'drm-kms-config etc-service-type
+		   (list `("modprobe.d/drm_kms.conf"
+			   ,drm-kms-config)))
+
+   ;; (service openvpn-client-service-type
+   ;; 	    (openvpn-client-configuration
+   ;; 	     (persist-tun? #t)
+   ;; 	     (remote
+   ;; 	      (list
+   ;; 	       (openvpn-remote-configuration
+   ;; 		(name "nyc.vpn.riseup.net")
+   ;; 		(port 1196))))))
+   
+   (service special-files-service-type
+	    `(("/bin/bash"   ,(file-append bash "/bin/bash"))
+	      ("/bin/python" ,(file-append python "/bin/python3"))
+	      ("/bin/python3" ,(file-append python "/bin/python3"))
+	      ("/bin/awk" ,(file-append gawk "/usr/bin/awk"))
+	      ("/usr/bin/awk" ,(file-append gawk "/usr/bin/awk"))
+	      ("/lib64/ld-linux-x86-64.so.2"
+               ,(file-append (canonical-package glibc)
+                             "/lib/ld-linux-x86-64.so.2"))))
+
+   (service nix-service-type
+	    (nix-configuration
+	     (extra-config '("trusted-users = root w96k"))))
+
+   (service postgresql-service-type)
+
+   %cpupower-service
+
+   ;; Doesn't start on boot sadly :(
+   %thinkfan-service
+
+   %x86-energy-perf-policy-service
+
+   (screen-locker-service xlockmore "xlock")
+
+
+   ;; (service xorg-server-service-type
+   ;; 	     (xorg-configuration
+   ;; 	      (keyboard-layout keyboard-layout)))
+
+   ;; (service hurd-vm-service-type
+   ;;          (hurd-vm-configuration
+   ;;           (disk-size (* 8 (expt 2 30))) ;12GiB
+   ;;           (memory-size 1024)))
+
+   (service slim-service-type
+	    (slim-configuration
+	     (xorg-configuration
+	      (xorg-configuration
+	       (drivers '("modesetting"))
+	       (keyboard-layout keyboard-layout)))))
+   
+   
+   (modify-services %desktop-services
+		    (delete gdm-service-type))))
+
+ (bootloader
+  (bootloader-configuration
+   (bootloader grub-bootloader)
+   (target "/dev/sda")
+   (keyboard-layout keyboard-layout)))
+ (swap-devices
+  (list
+   (swap-space
+    (target "/dev/sda1"))))
+ (file-systems
+  (cons*
+   (file-system
+    (mount-point "/")
+    (device
+     (uuid "c184f446-df67-4103-b28e-465ac8776f10"
+	   'ext4))
+    (type "ext4")
+    (options "discard"))
+
+   ;; Thinkpad doc HDD
+   
+   ;;(file-system
+   ;;(mount-point "/media/hdd/")
+   ;;(device
+   ;;  (uuid "71cb0818-baf3-4f7f-8bc2-7e2b0cca3488"
+   ;;	 'ext4))
+   ;; (type "ext4"))
+   
+   %base-file-systems)))
